# coding: utf-8
"""
    Snowflake Database API

    The Snowflake Database API is a REST API that you can use to access, update, and perform certain actions on Database resource in Snowflake.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, Field, field_validator

from typing import Any, ClassVar, Dict, List, Optional

from typing_extensions import Annotated


class DatabaseFromShare(BaseModel):

    name: Optional[Annotated[str, Field(strict=True)]] = None

    __properties = ["name"]

    @field_validator('name')
    def name_validate_regular_expression(cls, v):

        if v is None:
            return v
        if not re.match(r"""^\"([^\"]|\"\")+\"|[a-zA-Z_][a-zA-Z0-9_$]*$""", v):
            raise ValueError(
                r"""must validate the regular expression /^"([^"]|"")+"|[a-zA-Z_][a-zA-Z0-9_$]*$/"""
            )
        return v

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DatabaseFromShare:
        """Create an instance of DatabaseFromShare from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DatabaseFromShare:
        """Create an instance of DatabaseFromShare from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return DatabaseFromShare.parse_obj(obj)

        _obj = DatabaseFromShare.parse_obj({
            "name": obj.get("name"),
        })

        return _obj


from typing import Optional, List, Dict


class DatabaseFromShareModel():

    def __init__(
        self,  # optional properties
        name: Optional[str] = None,
    ):

        self.name = name

    __properties = ["name"]

    def _to_model(self):
        return DatabaseFromShare(name=self.name, )

    @classmethod
    def _from_model(cls, model) -> DatabaseFromShareModel:
        return DatabaseFromShareModel(name=model.name, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> DatabaseFromShareModel:
        """Create an instance of DatabaseFromShare from a dict"""
        return cls._from_model(DatabaseFromShare.from_dict(obj))


DatabaseFromShare._model_class = DatabaseFromShareModel
