# coding: utf-8
"""
    Snowflake Dynamic Table API

    The Snowflake Dynamic Table API is a REST API that you can use to access, update, and perform certain actions on Dynamic Tables resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.dynamic_table._generated.models.target_lag import TargetLag

from pydantic import ConfigDict, StrictInt

from typing import Any, ClassVar, Dict, List


class UserDefinedLag(TargetLag):

    seconds: StrictInt

    __properties = ["type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserDefinedLag:
        """Create an instance of UserDefinedLag from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict['type'] = TargetLag.get_child_model_discriminator_value(
            'UserDefinedLag')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserDefinedLag:
        """Create an instance of UserDefinedLag from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return UserDefinedLag.parse_obj(obj)

        _obj = UserDefinedLag.parse_obj({
            "seconds": obj.get("seconds"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.dynamic_table._generated.models.target_lag import TargetLag


class UserDefinedLagModel(TargetLag):

    def __init__(
        self,
        seconds: int,
        # optional properties
    ):
        super().__init__()
        self.seconds = seconds

    __properties = ["type"]

    def _to_model(self):
        return UserDefinedLag(seconds=self.seconds, )

    @classmethod
    def _from_model(cls, model) -> UserDefinedLagModel:
        return UserDefinedLagModel(seconds=model.seconds, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> UserDefinedLagModel:
        """Create an instance of UserDefinedLag from a dict"""
        return cls._from_model(UserDefinedLag.from_dict(obj))


UserDefinedLag._model_class = UserDefinedLagModel
