# coding: utf-8
"""
    Snowflake Image Repository API

    The Snowflake Image Repository API is a REST API that you can use to access, update, and perform common actions on Image Repository resource in Snowflake.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class ErrorResponse(BaseModel):

    message: Optional[StrictStr] = None

    code: Optional[StrictStr] = None

    error_code: Optional[StrictStr] = None

    request_id: Optional[StrictStr] = None

    __properties = ["message", "code", "error_code", "request_id"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ErrorResponse:
        """Create an instance of ErrorResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ErrorResponse:
        """Create an instance of ErrorResponse from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return ErrorResponse.parse_obj(obj)

        _obj = ErrorResponse.parse_obj({
            "message": obj.get("message"),
            "code": obj.get("code"),
            "error_code": obj.get("error_code"),
            "request_id": obj.get("request_id"),
        })

        return _obj


from typing import Optional, List, Dict


class ErrorResponseModel():

    def __init__(
        self,  # optional properties
        message: Optional[str] = None,
        code: Optional[str] = None,
        error_code: Optional[str] = None,
        request_id: Optional[str] = None,
    ):

        self.message = message
        self.code = code
        self.error_code = error_code
        self.request_id = request_id

    __properties = ["message", "code", "error_code", "request_id"]

    def _to_model(self):
        return ErrorResponse(
            message=self.message,
            code=self.code,
            error_code=self.error_code,
            request_id=self.request_id,
        )

    @classmethod
    def _from_model(cls, model) -> ErrorResponseModel:
        return ErrorResponseModel(
            message=model.message,
            code=model.code,
            error_code=model.error_code,
            request_id=model.request_id,
        )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> ErrorResponseModel:
        """Create an instance of ErrorResponse from a dict"""
        return cls._from_model(ErrorResponse.from_dict(obj))


ErrorResponse._model_class = ErrorResponseModel
