# coding: utf-8
"""
    Snowflake Schema API

    The Snowflake Schema API is a REST API that you can use to access, update, and perform certain actions on a Snowflake schema.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.schema._generated.models.point_of_time import PointOfTime

from pydantic import ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class PointOfTimeTimestamp(PointOfTime):

    timestamp: Optional[StrictStr] = None

    __properties = ["point_of_time_type", "reference"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PointOfTimeTimestamp:
        """Create an instance of PointOfTimeTimestamp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict[
            'point_of_time_type'] = PointOfTime.get_child_model_discriminator_value(
                'PointOfTimeTimestamp')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PointOfTimeTimestamp:
        """Create an instance of PointOfTimeTimestamp from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return PointOfTimeTimestamp.parse_obj(obj)

        _obj = PointOfTimeTimestamp.parse_obj({
            "reference":
            obj.get("reference"),
            "timestamp":
            obj.get("timestamp"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.schema._generated.models.point_of_time import PointOfTime


class PointOfTimeTimestampModel(PointOfTime):

    def __init__(
        self,  # optional properties
        reference: Optional[str] = None,
        timestamp: Optional[str] = None,
    ):
        super().__init__(reference=reference, )
        self.timestamp = timestamp

    __properties = ["point_of_time_type", "reference"]

    def _to_model(self):
        return PointOfTimeTimestamp(
            reference=self.reference,
            timestamp=self.timestamp,
        )

    @classmethod
    def _from_model(cls, model) -> PointOfTimeTimestampModel:
        return PointOfTimeTimestampModel(
            reference=model.reference,
            timestamp=model.timestamp,
        )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> PointOfTimeTimestampModel:
        """Create an instance of PointOfTimeTimestamp from a dict"""
        return cls._from_model(PointOfTimeTimestamp.from_dict(obj))


PointOfTimeTimestamp._model_class = PointOfTimeTimestampModel
