# coding: utf-8
"""
    Snowflake Services API

    The Snowflake Services API is a REST API that you can use to access, update, and perform certain actions on Services resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.service._generated.models.service_spec import ServiceSpec

from pydantic import ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List


class ServiceSpecInlineText(ServiceSpec):

    spec_text: StrictStr

    __properties = ["spec_type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ServiceSpecInlineText:
        """Create an instance of ServiceSpecInlineText from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict['spec_type'] = ServiceSpec.get_child_model_discriminator_value(
            'ServiceSpecInlineText')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ServiceSpecInlineText:
        """Create an instance of ServiceSpecInlineText from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return ServiceSpecInlineText.parse_obj(obj)

        _obj = ServiceSpecInlineText.parse_obj({
            "spec_text":
            obj.get("spec_text"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.service._generated.models.service_spec import ServiceSpec


class ServiceSpecInlineTextModel(ServiceSpec):

    def __init__(
        self,
        spec_text: str,
        # optional properties
    ):
        super().__init__()
        self.spec_text = spec_text

    __properties = ["spec_type"]

    def _to_model(self):
        return ServiceSpecInlineText(spec_text=self.spec_text, )

    @classmethod
    def _from_model(cls, model) -> ServiceSpecInlineTextModel:
        return ServiceSpecInlineTextModel(spec_text=model.spec_text, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> ServiceSpecInlineTextModel:
        """Create an instance of ServiceSpecInlineText from a dict"""
        return cls._from_model(ServiceSpecInlineText.from_dict(obj))


ServiceSpecInlineText._model_class = ServiceSpecInlineTextModel
