# coding: utf-8
"""
    Snowflake Session API

    The Snowflake Session API is a REST API that you can use to manage Snowflake sessions and session tokens.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Optional
from typing import Union
from snowflake.core.session._generated.pydantic_compatibility import BaseModel, Field, StrictStr


class CreateSessionRequest(BaseModel):
    role_name: Optional[StrictStr] = Field(None, alias="roleName")
    __properties = ["roleName"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateSessionRequest:
        """Create an instance of CreateSessionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateSessionRequest:
        """Create an instance of CreateSessionRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CreateSessionRequest.parse_obj(obj)

        _obj = CreateSessionRequest.parse_obj({
            "role_name": obj.get("roleName"),
        })
        return _obj


from typing import Optional, List, Dict


class CreateSessionRequestModel():

    def __init__(
        self,
        # optional properties
        role_name: Optional[str] = None,
    ):
        self.role_name = role_name

    __properties = ["roleName"]

    def _to_model(self):
        return CreateSessionRequest(role_name=self.role_name, )

    @classmethod
    def _from_model(cls, model) -> CreateSessionRequestModel:
        return CreateSessionRequestModel(role_name=model.role_name, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> CreateSessionRequestModel:
        """Create an instance of CreateSessionRequest from a dict"""
        return cls._from_model(CreateSessionRequest.from_dict(obj))


CreateSessionRequest._model_class = CreateSessionRequestModel
