# coding: utf-8
"""
    Snowflake Stage API

    The Snowflake Stage API is a REST API that you can use to access, update, and perform certain actions on stage resources in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.stage._generated.models.credentials import Credentials

from pydantic import ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class AzureCredentials(Credentials):

    azure_sas_token: Optional[StrictStr] = None

    __properties = ["credential_type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AzureCredentials:
        """Create an instance of AzureCredentials from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict[
            'credential_type'] = Credentials.get_child_model_discriminator_value(
                'AzureCredentials')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AzureCredentials:
        """Create an instance of AzureCredentials from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return AzureCredentials.parse_obj(obj)

        _obj = AzureCredentials.parse_obj({
            "azure_sas_token":
            obj.get("azure_sas_token"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.stage._generated.models.credentials import Credentials


class AzureCredentialsModel(Credentials):

    def __init__(
        self,  # optional properties
        azure_sas_token: Optional[str] = None,
    ):
        super().__init__()
        self.azure_sas_token = azure_sas_token

    __properties = ["credential_type"]

    def _to_model(self):
        return AzureCredentials(azure_sas_token=self.azure_sas_token, )

    @classmethod
    def _from_model(cls, model) -> AzureCredentialsModel:
        return AzureCredentialsModel(azure_sas_token=model.azure_sas_token, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> AzureCredentialsModel:
        """Create an instance of AzureCredentials from a dict"""
        return cls._from_model(AzureCredentials.from_dict(obj))


AzureCredentials._model_class = AzureCredentialsModel
