# coding: utf-8
"""
    Snowflake Table API

    The Snowflake Table API is a REST API that you can use to access, update, and perform certain actions on Tables resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class TableLike(BaseModel):

    name: Optional[StrictStr] = None

    __properties = ["name"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TableLike:
        """Create an instance of TableLike from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TableLike:
        """Create an instance of TableLike from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return TableLike.parse_obj(obj)

        _obj = TableLike.parse_obj({
            "name": obj.get("name"),
        })

        return _obj


from typing import Optional, List, Dict


class TableLikeModel():

    def __init__(
        self,  # optional properties
        name: Optional[str] = None,
    ):

        self.name = name

    __properties = ["name"]

    def _to_model(self):
        return TableLike(name=self.name, )

    @classmethod
    def _from_model(cls, model) -> TableLikeModel:
        return TableLikeModel(name=model.name, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> TableLikeModel:
        """Create an instance of TableLike from a dict"""
        return cls._from_model(TableLike.from_dict(obj))


TableLike._model_class = TableLikeModel
