# coding: utf-8
"""
    Snowflake Task API

    The Snowflake Task API is a REST API that you can use to access, update, and perform certain actions on task resources in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.task._generated.models.task_schedule import TaskSchedule

from pydantic import ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List


class CronSchedule(TaskSchedule):

    cron_expr: StrictStr

    timezone: StrictStr

    __properties = ["schedule_type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CronSchedule:
        """Create an instance of CronSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict[
            'schedule_type'] = TaskSchedule.get_child_model_discriminator_value(
                'CronSchedule')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CronSchedule:
        """Create an instance of CronSchedule from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return CronSchedule.parse_obj(obj)

        _obj = CronSchedule.parse_obj({
            "cron_expr": obj.get("cron_expr"),
            "timezone": obj.get("timezone"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.task._generated.models.task_schedule import TaskSchedule


class CronScheduleModel(TaskSchedule):

    def __init__(
        self,
        cron_expr: str,
        timezone: str,
        # optional properties
    ):
        super().__init__()
        self.cron_expr = cron_expr
        self.timezone = timezone

    __properties = ["schedule_type"]

    def _to_model(self):
        return CronSchedule(
            cron_expr=self.cron_expr,
            timezone=self.timezone,
        )

    @classmethod
    def _from_model(cls, model) -> CronScheduleModel:
        return CronScheduleModel(
            cron_expr=model.cron_expr,
            timezone=model.timezone,
        )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> CronScheduleModel:
        """Create an instance of CronSchedule from a dict"""
        return cls._from_model(CronSchedule.from_dict(obj))


CronSchedule._model_class = CronScheduleModel
