# coding: utf-8
"""
    Snowflake Task API

    The Snowflake Task API is a REST API that you can use to access, update, and perform certain actions on task resources in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.task._generated.models.task_schedule import TaskSchedule

from pydantic import ConfigDict, StrictInt

from typing import Any, ClassVar, Dict, List


class MinutesSchedule(TaskSchedule):

    minutes: StrictInt

    __properties = ["schedule_type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MinutesSchedule:
        """Create an instance of MinutesSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={},
                       exclude_none=True))

        _dict[
            'schedule_type'] = TaskSchedule.get_child_model_discriminator_value(
                'MinutesSchedule')

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MinutesSchedule:
        """Create an instance of MinutesSchedule from a dict"""

        if obj is None:
            return None

        if type(obj) is not dict:
            return MinutesSchedule.parse_obj(obj)

        _obj = MinutesSchedule.parse_obj({
            "minutes": obj.get("minutes"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.task._generated.models.task_schedule import TaskSchedule


class MinutesScheduleModel(TaskSchedule):

    def __init__(
        self,
        minutes: int,
        # optional properties
    ):
        super().__init__()
        self.minutes = minutes

    __properties = ["schedule_type"]

    def _to_model(self):
        return MinutesSchedule(minutes=self.minutes, )

    @classmethod
    def _from_model(cls, model) -> MinutesScheduleModel:
        return MinutesScheduleModel(minutes=model.minutes, )

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> MinutesScheduleModel:
        """Create an instance of MinutesSchedule from a dict"""
        return cls._from_model(MinutesSchedule.from_dict(obj))


MinutesSchedule._model_class = MinutesScheduleModel
